Subject: Re: bug#26339: [PATCH 02/18] system: Add extlinux support.

From: [email-masked] (Ludovic Courtès)
Date: Fri, 12 May 2017 10:26:53 +0200

Hello,

Danny Milosavljevic <[email-masked]> skribis:

> On Tue, 09 May 2017 22:40:23 +0200
> [email-masked] (Ludovic Courtès) wrote:
>
>> > -> It was ok with one bootloader, it's more problematic with multiple  
>> > bootloaders. For example switching between two generations with two
>> > different bootloaders.  
>> 
>> OTOH, if it turns out to be safer to keep the current bootloader, which
>> is likely I think, then perhaps it’s best to not try to change.
>> 
>> I mean, I prefer a rollback that doesn’t roll back the bootloader over a
>> rollback that tries to do something smart and makes the system
>> unbootable.
>
> If there is a switch between extlinux and grub, the bootloader config file format (and name, too) will change.
>
> So if you do switch the config file out but don't switch the actual bootloader out it will not boot, right?

Unless you regenerate the bootloader’s config file upon
‘switch-configuration’.

> That means we have to take care that this doesn't happen.
>
> I still think an easy way would be to just always install the config files for all the bootloaders that we support.  That way if there is a bootloader that knows any of the configs, it will boot.  Can't think of a downside either.

Yes, that’s also an option.  The downside would be that if we register
all of these as GC roots, then we end up retaining more than actually
needed.

Thanks,
Ludo’.